# Code written by Theodore Lindsey for his master's thesis.
# Fall 2016
# Liscensed under the GNU Lesser General Public License v3
class Rule:
    def __init__(self, lhs):
        self.lhs = lhs
        self.rhs = None
        self.correct = None
        self.incorrect = None

    def __str__(self):
        return " & ".join([str(c) for c in self.lhs]) + " -> {}".format(self.rhs)

    def strength(self):
        return len(self.correct)

    def specificity(self):
        return len(self.lhs)

    def coverage(self):
        return self.correct.union(self.incorrect)

    def score(self):
        return self.strength() * self.specificity()

    def stats(self, concept):
        st = {}

        st["cov"] = self.coverage()
        st["cov#"] = len(st["cov"])

        st["cor"] = self.correct
        st["cor#"] = len(st["cor"])

        st["icor"] = self.incorrect
        st["icor#"] = len(st["icor"])

        st["pr"] = st["cor#"] / st["cov#"]
        st["sp"] = self.specificity()
        st["sc"] = self.score()
        return st